## retroarch 1.3.6+dfsg1

=== Makefile ===
HAVE_FILE_LOGGER=1
NEED_CXX_LINKER=0
MISSING_DECLS   =0

ifneq ($(C90_BUILD),)
   C89_BUILD=1
endif

include config.mk

TARGET = retroarch

OBJDIR := obj-unix

ifeq ($(GLOBAL_CONFIG_DIR),)
   GLOBAL_CONFIG_DIR = /etc
endif

OBJ := 
LIBS :=
DEFINES := -DHAVE_CONFIG_H -DRARCH_INTERNAL -DHAVE_OVERLAY
DEFINES += -DGLOBAL_CONFIG_DIR='"$(GLOBAL_CONFIG_DIR)"'

ifneq ($(findstring Win32,$(OS)),)
   LDFLAGS += -static-libgcc
endif

include Makefile.common

ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang"),1)
   DEFINES +=  -Wno-invalid-source-encoding
endif

HEADERS = $(wildcard */*/*.h) $(wildcard */*.h) $(wildcard *.h)

ifeq ($(MISSING_DECLS), 1)
   DEFINES += -Werror=missing-declarations
endif

ifeq ($(HAVE_DYLIB), 1)
   LIBS += $(DYLIB_LIB)
endif

ifeq ($(HAVE_DYNAMIC), 1)
   LIBS += $(DYLIB_LIB)
else
   LIBS += $(libretro)
endif

ifneq ($(V),1)
   Q := @
endif

ifeq ($(DEBUG), 1)
   OPTIMIZE_FLAG = -O0 -g
else
   OPTIMIZE_FLAG = -O3 -ffast-math
   ifneq ($(findstring Win32,$(OS)),)
      LDFLAGS += -mwindows
   endif
endif

CFLAGS   += -Wall $(OPTIMIZE_FLAG) $(INCLUDE_DIRS) $(DEBUG_FLAG) -I.

APPEND_CFLAGS := $(CFLAGS)
CXXFLAGS += $(APPEND_CFLAGS) -std=c++11 -D__STDC_CONSTANT_MACROS
OBJCFLAGS :=  $(CFLAGS) -D__STDC_CONSTANT_MACROS

ifeq ($(CXX_BUILD), 1)
   LINK = $(CXX)
   CFLAGS   := $(CXXFLAGS) -xc++
   CFLAGS   += -DCXX_BUILD
   CXXFLAGS += -DCXX_BUILD
else
   ifeq ($(NEED_CXX_LINKER),1)
      LINK = $(CXX)
   else ifeq ($(findstring Win32,$(OS)),)
      LINK = $(CC)
   else
      # directx-related code is c++
      LINK = $(CXX)
   endif

   ifneq ($(GNU90_BUILD), 1)
      ifneq ($(findstring icc,$(CC)),)
         CFLAGS += -std=c99 -D_GNU_SOURCE
      else
         CFLAGS += -std=gnu99 -D_GNU_SOURCE
      endif
   endif

   ifneq ($(C89_BUILD),)
      CFLAGS += -std=c89 -ansi -pedantic -Werror=pedantic -Wno-long-long
   endif
endif

ifeq ($(NOUNUSED), yes)
   CFLAGS += -Wno-unused-result
   CXXFLAGS += -Wno-unused-result
endif
ifeq ($(NOUNUSED_VARIABLE), yes)
   CFLAGS += -Wno-unused-variable
   CXXFLAGS += -Wno-unused-variable
endif

RARCH_OBJ := $(addprefix $(OBJDIR)/,$(OBJ))

ifneq ($(SANITIZER),)
    CFLAGS   := -fsanitize=$(SANITIZER) $(CFLAGS)
    CXXFLAGS := -fsanitize=$(SANITIZER) $(CXXFLAGS)
    LDFLAGS  := -fsanitize=$(SANITIZER) $(LDLAGS)
endif

ifneq ($(findstring $(GPERFTOOLS),profiler),)
   LIBS += -lprofiler
endif
ifneq ($(findstring $(GPERFTOOLS),tcmalloc),)
   LIBS += -ltcmalloc
endif

all: $(TARGET) config.mk

ifeq ($(MAKECMDGOALS),clean)
config.mk:
else
-include $(RARCH_OBJ:.o=.d)
config.mk: configure qb/*
	@echo "config.mk is outdated or non-existing. Run ./configure again."
	@exit 1
endif

retroarch: $(RARCH_OBJ)
	@$(if $(Q), $(shell echo echo LD $@),)
	$(Q)$(LINK) -o $@ $(RARCH_OBJ) $(LIBS) $(LDFLAGS) $(LIBRARY_DIRS)

$(OBJDIR)/%.o: %.c config.h config.mk
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo CC $<),)
	$(Q)$(CC) $(CFLAGS) $(DEFINES) -MMD -c -o $@ $<

$(OBJDIR)/%.o: %.cpp config.h config.mk
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo CXX $<),)
	$(Q)$(CXX) $(CXXFLAGS) $(DEFINES) -MMD -c -o $@ $<

$(OBJDIR)/%.o: %.m
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo OBJC $<),)
	$(Q)$(CXX) $(OBJCFLAGS) $(DEFINES) -MMD -c -o $@ $<

.FORCE:

$(OBJDIR)/git_version.o: git_version.c .FORCE
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo CC $<),)
	$(Q)$(CC) $(CFLAGS) $(DEFINES) -MMD -c -o $@ $<

$(OBJDIR)/%.o: %.S config.h config.mk $(HEADERS)
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo AS $<),)
	$(Q)$(CC) $(CFLAGS) $(ASFLAGS) $(DEFINES) -c -o $@ $<

$(OBJDIR)/%.o: %.rc $(HEADERS)
	@mkdir -p $(dir $@)
	@$(if $(Q), $(shell echo echo WINDRES $<),)
	$(Q)$(WINDRES) -o $@ $<

install: $(TARGET)
	rm -f $(OBJDIR)/git_version.o
	mkdir -p $(DESTDIR)$(PREFIX)/bin 2>/dev/null || /bin/true
	mkdir -p $(DESTDIR)$(GLOBAL_CONFIG_DIR) 2>/dev/null || /bin/true
	mkdir -p $(DESTDIR)$(PREFIX)/share/applications 2>/dev/null || /bin/true
	mkdir -p $(DESTDIR)$(MAN_DIR)/man6 2>/dev/null || /bin/true
	mkdir -p $(DESTDIR)$(PREFIX)/share/pixmaps 2>/dev/null || /bin/true
	install -m755 $(TARGET) $(DESTDIR)$(PREFIX)/bin 
	install -m755 tools/cg2glsl.py $(DESTDIR)$(PREFIX)/bin/retroarch-cg2glsl
	install -m644 retroarch.cfg $(DESTDIR)$(GLOBAL_CONFIG_DIR)/retroarch.cfg
	install -m644 retroarch.desktop $(DESTDIR)$(PREFIX)/share/applications
	install -m644 docs/retroarch.6 $(DESTDIR)$(MAN_DIR)/man6
	install -m644 docs/retroarch-cg2glsl.6 $(DESTDIR)$(MAN_DIR)/man6
	install -m644 media/retroarch.svg $(DESTDIR)$(PREFIX)/share/pixmaps

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/retroarch
	rm -f $(DESTDIR)$(PREFIX)/bin/retroarch-cg2glsl
	rm -f $(DESTDIR)$(GLOBAL_CONFIG_DIR)/retroarch.cfg
	rm -f $(DESTDIR)$(PREFIX)/share/applications/retroarch.desktop
	rm -f $(DESTDIR)$(MAN_DIR)/man6/retroarch.6
	rm -f $(DESTDIR)$(MAN_DIR)/man6/retroarch-cg2glsl.6
	rm -f $(DESTDIR)$(PREFIX)/share/pixmaps/retroarch.svg

clean:
	rm -rf $(OBJDIR)
	rm -f $(TARGET)
	rm -f *.d

.PHONY: all install uninstall clean

=== audio_filters/Makefile ===
compiler    := gcc
extra_flags :=
use_neon    := 0
build       = release
DYLIB	      := so

ifeq ($(platform),)
   platform = unix
   ifeq ($(shell uname -a),)
      platform = win
   else ifneq ($(findstring MINGW,$(shell uname -a)),)
      platform = win
   else ifneq ($(findstring Darwin,$(shell uname -a)),)
      platform = osx
      arch = intel
      ifeq ($(shell uname -p),powerpc)
         arch = ppc
      endif
   else ifneq ($(findstring win,$(shell uname -a)),)
      platform = win
   endif
endif

ifeq ($(platform),gcc)
   extra_rules_gcc := $(shell $(compiler) -dumpmachine)
endif

ifneq (,$(findstring armv7,$(extra_rules_gcc)))
   extra_flags += -mcpu=cortex-a9 -mtune=cortex-a9 -mfpu=neon
   use_neon := 1
endif

ifneq (,$(findstring hardfloat,$(extra_rules_gcc)))
   extra_flags += -mfloat-abi=hard
endif

ifeq (release,$(build))
   extra_flags += -O2
endif

ifeq (debug,$(build))
   extra_flags += -O0 -g
endif

ldflags := $(LDFLAGS) -shared -lm -Wl,--version-script=link.T

ifeq ($(platform), unix)
   DYLIB = so
else ifeq ($(platform), osx)
   compiler := $(CC)
   DYLIB = dylib
   ldflags := -dynamiclib
else
   extra_flags += -static-libgcc -static-libstdc++
   DYLIB = dll
endif

CC      := $(compiler) -Wall
CXX     := $(subst CC,++,$(compiler)) -std=gnu++0x -Wall
flags   := $(CFLAGS) -fPIC $(extra_flags) -I../../libretro-common/include
asflags := $(ASFLAGS) -fPIC  $(extra_flags)
objects :=

ifeq (1,$(use_neon))
   ASMFLAGS := -INEON/asm 
   asflags += -mfpu=neon
endif

plugs := $(wildcard *.c)
objects := $(plugs:.c=.o)
targets := $(objects:.o=.$(DYLIB))

all: build;

%.o: %.S
	$(CC) -c -o $@ $(asflags)  $(ASMFLAGS)  $<

%.o: %.c
	$(CC) -c -o $@ $(flags) $<

%.$(DYLIB): %.o
	$(CC) -o $@ $(ldflags) $(flags) $^

build: $(targets)

clean:
	rm -f *.o
	rm -f *.$(DYLIB)

strip:
	strip -s *.$(DYLIB)

=== libretro-ffmpeg/Makefile ===
LIBRETRO_SWITCH        = 0

INTERNAL_LIBAVCODEC    = 0
INTERNAL_LIBAVFORMAT   = 0
INTERNAL_LIBAVUTIL     = 0
INTERNAL_LIBSWRESAMPLE = 0
INTERNAL_LIBSWSCALE    = 0

INTERNAL_LIBFLAC       = 0
INTERNAL_LIBOGG        = 0
INTERNAL_LIBLAME       = 0
INTERNAL_LIBFAAC       = 0
INTERNAL_LIBSPEEX      = 0
INTERNAL_LIBTHEORA     = 0
INTERNAL_LIBOPUS       = 0  
INTERNAL_LIBVORBIS     = 0
INTERNAL_WEBP          = 0
INTERNAL_ZLIB          = 0
INTERNAL_WAVPACK       = 0
INTERNAL_XVIDCORE      = 0
INTERNAL_VPX           = 0


BAKE_IN_FFMPEG := 0

#CPU Optimization flags
HAVE_SSE2 = 0
HAVE_MMX = 0
HAVE_THREADS = 1

#Additional codec support for internal FFmpeg
HAVE_WAVPACK   = 0
HAVE_LIBSPEEX  = 0
HAVE_LIBWEBP   = 0
HAVE_LIBOGG    = 0
HAVE_LIBX264   = 0
HAVE_LIBX265   = 0
HAVE_LIBFAAC   = 0
HAVE_LIBFLAC   = 0
HAVE_LIBLAME   = 0
HAVE_LIBTWOLAME = 0
HAVE_LIBVORBIS = 0
HAVE_LIBTHEORA = 0
HAVE_LIBOPUS   = 0
HAVE_ZLIB      = 0

#Video support
OPENGL = 1
HAVE_CODEC_HW = 0

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

system = $(shell uname -m)

ifeq ($(system),x86_64)
ARCH_X86 = 1
ARCH_X86_64 = 1
endif

TARGET_NAME := ffmpeg

ifneq (,$(findstring unix,$(platform)))
	ARCH_X86 = 1
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined -fPIC
ifeq ($(OPENGL),1)
   GL_LIB := -lGL
   CFLAGS += -DHAVE_OPENGL
   HAVE_GL := 1
	HAVE_GL_FFT := 1
endif
   HAVE_SSA := 1

   LIBS = $(shell pkg-config libass --libs) -pthread
   CFLAGS += $(shell pkg-config libass --cflags) -pthread
	CFLAGS += -DHAVE_STRUCT_SOCKADDR_STORAGE -DHAVE_STRUCT_ADDRINFO -DHAVE_FMINF
	HAVE_POLL_H = 1
	HAVE_GETADDRINFO = 1
	HAVE_NETWORK = 1
	HAVE_SOCKLEN = 1
	HAVE_PTHREADS = 1
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += $(shell pkg-config libavcodec --libs)
   CFLAGS += $(shell pkg-config libavcodec --cflags)
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += $(shell pkg-config libavformat --libs)
   CFLAGS += $(shell pkg-config libavformat --cflags)
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += $(shell pkg-config libswresample --libs)
   CFLAGS += $(shell pkg-config libswresample --cflags)
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += $(shell pkg-config libavutil --libs)
   CFLAGS += $(shell pkg-config libavutil --cflags)
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
   LIBS += $(shell pkg-config libswscale --libs)
   CFLAGS += $(shell pkg-config libswscale --cflags)
endif
else ifneq (,$(findstring osx,$(platform)))
	ARCH_X86 = 1
   LIBRETRO_SWITCH = 1
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   CFLAGS += -I. -I.. -DHAVE_FMINF
ifeq ($(OPENGL),1)
   GL_LIB := -framework OpenGL
   HAVE_GL := 1
   HAVE_GL_FFT := 1
   CFLAGS += -DHAVE_GL
endif
HAVE_PTHREADS = 1
   OSXVER = `sw_vers -productVersion | cut -d. -f 2`
   OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
   fpic += -mmacosx-version-min=10.1
	CFLAGS += -DHAVE_STRUCT_SOCKADDR_STORAGE -DHAVE_STRUCT_ADDRINFO
	HAVE_POLL_H = 1
	HAVE_GETADDRINFO = 1
	HAVE_NETWORK = 1
	HAVE_SOCKLEN = 1

   LIBS = $(shell pkg-config libass --libs) -pthread
   CFLAGS += $(shell pkg-config libass --cflags) -pthread
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += $(shell pkg-config libavcodec --libs)
   CFLAGS += $(shell pkg-config libavcodec --cflags)
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += $(shell pkg-config libavformat --libs)
   CFLAGS += $(shell pkg-config libavformat --cflags)
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += $(shell pkg-config libswresample --libs)
   CFLAGS += $(shell pkg-config libswresample --cflags)
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += $(shell pkg-config libavutil --libs)
   CFLAGS += $(shell pkg-config libavutil --cflags)
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
   LIBS += $(shell pkg-config libswscale --libs)
   CFLAGS += $(shell pkg-config libswscale --cflags)
endif
else ifneq (,$(findstring win,$(platform)))
	ARCH_X86 = 1
   CC = gcc
	CXX = g++
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -Iffmpeg
ifeq ($(OPENGL),1)
   GL_LIB := -lopengl32
   CFLAGS += -DHAVE_OPENGL
   HAVE_GL := 1
	HAVE_GL_FFT := 1
	WIN32_PLATFORM := 1
endif
   LIBS += -L.
ifneq ($(INTERNAL_LIBAVCODEC),1)
   LIBS += -lavcodec
endif
ifneq ($(INTERNAL_LIBAVFORMAT),1)
   LIBS += -lavformat
endif
ifneq ($(INTERNAL_LIBSWRESAMPLE),1)
   LIBS += -lswresample
endif
ifneq ($(INTERNAL_LIBAVUTIL),1)
   LIBS += -lavutil
endif
ifneq ($(INTERNAL_LIBSWSCALE),1)
	LIBS += -lswscale
endif
endif

ifeq ($(LIBRETRO_SWITCH),1)
CFLAGS += -DLIBRETRO_SWITCH=1
INTERNAL_LIBAVCODEC    = 1
INTERNAL_LIBAVFORMAT   = 1
INTERNAL_LIBAVUTIL     = 1
INTERNAL_LIBSWRESAMPLE = 1
INTERNAL_LIBSWSCALE    = 1

INTERNAL_LIBFLAC       = 1
INTERNAL_LIBOGG        = 1
INTERNAL_LIBLAME       = 1
INTERNAL_LIBFAAC       = 1
INTERNAL_LIBVORBIS     = 1
INTERNAL_ZLIB          = 1
endif

ifeq ($(INTERNAL_LIBAVCODEC),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBAVFORMAT),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBSWRESAMPLE),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBWSCALE),1)
	BAKE_IN_FFMPEG += 1
endif

ifeq ($(INTERNAL_LIBAVUTIL),1)
	BAKE_IN_FFMPEG += 1
endif

CFLAGS += -D__LIBRETRO__

ifeq ($(HAVE_SSA), 1)
   LIBS += $(shell pkg-config libass --libs)
   CFLAGS += -DHAVE_SSA
endif

LIBRETROCOMM_DIR := ../../libretro-common
DEPS_DIR         := ../../deps

LIBAVCODEC_SOURCE :=
LIBAVFORMAT_SOURCE :=
LIBAVUTIL_SOURCE :=
LIBRETRO_SOURCE := ffmpeg_core.c \
						 $(LIBRETROCOMM_DIR)/queues/fifo_queue.c \
						 $(LIBRETROCOMM_DIR)/rthreads/rthreads.c
DEPS_SOURCE :=

ifeq ($(HAVE_BIGENDIAN),1)
CPUOPTS += -DHAVE_BIGENDIAN=1
else
CPUOPTS += -DHAVE_BIGENDIAN=0
endif

ifneq ($(BAKE_IN_FFMPEG),0)

ifeq ($(INTERNAL_LIBAVCODEC),1)

ifeq ($(INTERNAL_ZLIB),0)
	LIBS += -lz
	HAVE_ZLIB = 1
else
	HAVE_ZLIB = 1
	DEPS_SOURCE += $(wildcard libz/*.c)
endif

ifeq ($(INTERNAL_LIBFLAC),0)
	LIBS += -lFLAC
	HAVE_LIBFLAC = 1
else
	CFLAGS += -I. -IlibFLAC -IlibFLAC/include -DHAVE_LROUND
	HAVE_LIBFLAC = 1
	DEPS_SOURCE += $(wildcard libFLAC/*.c)
endif

ifeq ($(INTERNAL_LIBOPUS),0)
	#LIBS += -lopus
	#HAVE_LIBOPUS = 1
else
	#CFLAGS += -I. -Ilibopus -Ilibopus/celt -DUSE_ALLOCA -DOPUS_BUILD
	#HAVE_LIBOPUS = 1
	#DEPS_SOURCE += $(wildcard libopus/*.c) $(wildcard libopus/celt/*.c)
endif

ifeq ($(INTERNAL_LIBVORBIS),0)
	LIBS += -lvorbis -lvorbisenc -lvorbisfile
	HAVE_LIBVORBIS = 1
else
	CFLAGS += -DOV_EXCLUDE_STATIC_CALLBACKS -Ivorbis
	HAVE_LIBVORBIS = 1
	DEPS_SOURCE += $(wildcard vorbis/*.c)
endif

ifeq ($(INTERNAL_LIBLAME),0)
	LIBS += -lmp3lame
	HAVE_LIBLAME = 1
else
	HAVE_LIBLAME = 1
	CFLAGS += -Ilibmp3lame
	DEPS_SOURCE += $(wildcard libmp3lame/*.c)
endif

ifeq ($(INTERNAL_LIBSPEEX),0)
	LIBS += -lspeex
	HAVE_LIBSPEEX = 1
endif

ifeq ($(INTERNAL_WEBP),0)
	LIBS += -lwebp
	HAVE_LIBWEBP = 1
endif

ifeq ($(INTERNAL_LIBOGG),0)
	LIBS += -logg
	HAVE_LIBOGG = 1
else
	CFLAGS += -DOV_EXCLUDE_STATIC_CALLBACKS
	HAVE_LIBOGG = 1
	DEPS_SOURCE += ogg/bitwise.c ogg/framing.c
endif

ifeq ($(INTERNAL_LIBFAAC),0)
	LIBS += -lfaac
	HAVE_LIBFAAC = 1
else
	CFLAGS += -Ilibfaac
	HAVE_LIBFAAC = 1
	DEPS_SOURCE += $(wildcard libfaac/*.c)
endif

ifeq ($(INTERNAL_WAVPACK),0)
	LIBS += -lwavpack
	HAVE_WAVPACK = 1
endif

ifeq ($(INTERNAL_XVIDCORE),0)
   LIBS += -lxvidcore
endif

ifeq ($(INTERNAL_LIBTHEORA),0)
	LIBS += -ltheora -ltheoraenc -ltheoradec
	HAVE_LIBTHEORA = 1
endif

ifeq ($(INTERNAL_VPX),0)
	LIBS += -lvpx
	HAVE_VPX = 1
endif

endif

LIBS += -lm

CFLAGS += -DCONFIG_SMALL=0

## CPU Flags

#Blackfin DSP. Pretty sure we won't target this for libretro (if ever).

CPUOPTS += -DARCH_BFIN=0

#We can reasonably assume MMX will be there on all x86 CPUs from 1997 and up at least
#SSE2 can be assumed from Pentium 4 and up - can be switched on or off with the switch HAVE_SSE2

CPUOPTS += -DHAVE_AMD3DNOW_INLINE=0
CPUOPTS += -DHAVE_AMD3DNOWEXT_EXTERNAL=0

ifeq ($(ARCH_X86),1)
CPUOPTS += -DARCH_X86=1
ifneq ($(ARCH_X86_64),1)
CPUOPTS += -DARCH_X86_32=1
endif
CPUOPTS += -DHAVE_MMX2=0
CPUOPTS += -DHAVE_EBX_AVAILABLE=1
CPUOPTS += -DHAVE_EBP_AVAILABLE=1
ifeq ($(HAVE_MMX), 1)
CPUOPTS += -DHAVE_MMX=1
CPUOPTS += -DHAVE_MMXEXT=1
CPUOPTS += -DHAVE_MMX_EXTERNAL=1
CPUOPTS += -DHAVE_MMXEXT_EXTERNAL=1
CPUOPTS += -DHAVE_AMD3DNOW_EXTERNAL=0
CPUOPTS += -DHAVE_MMX_INLINE=1 -DHAVE_MMXEXT_INLINE=0
else
CPUOPTS += -DHAVE_MMX=0
CPUOPTS += -DHAVE_MMXEXT=0
CPUOPTS += -DHAVE_MMX_EXTERNAL=0
CPUOPTS += -DHAVE_MMXEXT_EXTERNAL=0
CPUOPTS += -DHAVE_AMD3DNOW_EXTERNAL=0
CPUOPTS += -DHAVE_XOP_EXTERNAL=0
CPUOPTS += -DHAVE_MMX_INLINE=0 -DHAVE_MMXEXT_INLINE=0
endif
CPUOPTS += -DHAVE_ALIGNED_STACK -DHAVE_FAST_UNALIGNED=0

ifeq ($(HAVE_SSE1),1)
CPUOPTS += -DHAVE_SSE=1
CPUOPTS += -DHAVE_SSE_EXTERNAL=1
else
CPUOPTS += -DHAVE_SSE=0
CPUOPTS += -DHAVE_SSE_EXTERNAL=0
endif

ifeq ($(HAVE_SSE2),1)
CPUOPTS += -DHAVE_SSE2=1
CPUOPTS += -DHAVE_SSE2_EXTERNAL=1
CPUOPTS += -DHAVE_SSE2_INLINE=1

else
CPUOPTS += -DHAVE_SSE2=0
CPUOPTS += -DHAVE_SSE2_EXTERNAL=0
CPUOPTS += -DHAVE_SSE2_INLINE=0

endif

CPUOPTS += -DHAVE_FMA3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE4_EXTERNAL=0
CPUOPTS += -DHAVE_SSE42_EXTERNAL=0
CPUOPTS += -DHAVE_AVX_EXTERNAL=0
CPUOPTS += -DHAVE_AVX2_EXTERNAL=0
else
CPUOPTS += -DHAVE_FMA3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE_EXTERNAL=0
CPUOPTS += -DHAVE_SSE2_INLINE=0
CPUOPTS += -DHAVE_SSE2_EXTERNAL=0
CPUOPTS += -DHAVE_SSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSSE3_EXTERNAL=0
CPUOPTS += -DHAVE_SSE4_EXTERNAL=0
CPUOPTS += -DHAVE_SSE42_EXTERNAL=0
CPUOPTS += -DHAVE_AVX_EXTERNAL=0
CPUOPTS += -DHAVE_AVX2_EXTERNAL=0
endif

ifeq ($(ARCH_X86_64),1)
CPUOPTS += -DARCH_X86_64=1
CPUOPTS += -DARCH_X86_32=0
CFLAGS += -DHAVE_FAST_64BIT=1
else
CPUOPTS += -DARCH_X86_64=0
CFLAGS += -DHAVE_FAST_64BIT=0
endif

#This is ARMv8/NEON
ifeq ($(ARCH_AARCH64),1)
CPUOPTS += -DARCH_AARCH64=1
else
CPUOPTS += -DARCH_AARCH64=0
endif

ifeq ($(ARCH_ARM),1)
CPUOPTS += -DARCH_ARM=1
else
CPUOPTS += -DARCH_ARM=0
endif
ifeq ($(ARCH_PPC),1)
CPUOPTS += -DARCH_PPC=1
else
CPUOPTS += -DARCH_PPC=0
endif

ifeq ($(HAVE_ALTIVEC),1)
CPUOPTS += -DHAVE_ALTIVEC=1
else
CPUOPTS += -DHAVE_ALTIVEC=0
endif

ifeq ($(ARCH_MIPS),1)
# Not sure if we can just define this for all MIPS archs - probably not
CPUOPTS += -DHAVE_MIPSFPU=1
CPUOPTS += -DARCH_MIPS=1
CPUOPTS += -DHAVE_MIPSDSPR1=0
else
CPUOPTS += -DHAVE_MIPSFPU=0
CPUOPTS += -DARCH_MIPS=0
CPUOPTS += -DHAVE_MIPSDSPR1=0
endif

ifeq ($(ARCH_ALPHA),1)
CPUOPTS += -DARCH_ALPHA=1
else
CPUOPTS += -DARCH_ALPHA=0
endif

CFLAGS += -I$(BASE_DIR) -I. -DHAVE_CBRT -DHAVE_CBRTF -DHAVE_ISINF -DHAVE_ISNAN -DHAVE_RINT -DHAVE_LRINT -DHAVE_LRINTF -DHAVE_ROUND -DHAVE_ROUNDF -DHAVE_TRUNC -DHAVE_TRUNCF -DHAVE_YASM=0 $(CPUOPTS)

ifeq ($(HAVE_POLL_H),1)
CFLAGS += -DHAVE_POLL_H
endif

ifeq ($(HAVE_SOCKLEN),1)
CFLAGS += -DHAVE_SOCKLEN_T
endif

ifeq ($(HAVE_GETADDRINFO),1)
CFLAGS += -DHAVE_GETADDRINFO=1
endif

ifeq ($(HAVE_NETWORK),1)
CFLAGS += -DCONFIG_NETWORK=1
endif

# Threading flags

ifeq ($(HAVE_THREADS),1)
CFLAGS += -DHAVE_THREADS=1

ifeq ($(ARCH_X86),1)
CFLAGS += -DHAVE_ATOMICS_GCC=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(ARCH_X86_64),1)
CFLAGS += -DHAVE_ATOMICS_GCC=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(WIN32_PLATFORM),1)
CFLAGS += HAVE_ATOMICS_WIN32=1 -DHAVE_ATOMICS_NATIVE=1
endif

ifeq ($(HAVE_PTHREADS),1)
CFLAGS += -DHAVE_PTHREADS=1
endif

else
CFLAGS += -DHAVE_THREADS=0
CFLAGS += -DHAVE_PTHREADS=0
endif

ifeq ($(HAVE_LIBLAME),1)
CFLAGS += -DCONFIG_LIBMP3LAME=1 \
			 -DCONFIG_LIBMP3LAME_ENCODER=1
else
CFLAGS += -DCONFIG_LIBMP3LAME=0 \
			 -DCONFIG_LIBMP3LAME_ENCODER=0
endif

ifeq ($(HAVE_LIBVORBIS),1)
CFLAGS += -DCONFIG_LIBVORBIS=1 \
			 -DCONFIG_VORBIS_ENCODER=1 \
			 -DCONFIG_LIBVORBIS_ENCODER=1 \

=== libretro-test-gl-ff/Makefile ===
ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
		arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	system_platform = osx
	arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

TARGET_NAME = testgl_ff

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   GL_LIB := -lGL
else ifneq (,$(findstring osx,$(platform)))
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   GL_LIB := -framework OpenGL
   CFLAGS += -DOSX
	ifeq ($(arch),ppc)
		CFLAGS += -D__ppc__ -DOSX_PPC
	endif
	OSXVER = `sw_vers -productVersion | cut -d. -f 2`
	OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
	fpic += -mmacosx-version-min=10.1
else ifeq ($(platform), pi)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/vmcs_host/linux
   GLES := 1
   LIBS += -L/opt/vc/lib
else ifneq (,$(findstring ios,$(platform)))
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
endif

   GL_LIB := -framework OpenGLES
   DEFINES := -DIOS
   CFLAGS += -DGLES $(DEFINES)
   CC = cc -arch armv7 -isysroot $(IOSSDK)
ifeq ($(platform),ios9)
	CC     += -miphoneos-version-min=8.0
	CFLAGS += -miphoneos-version-min=8.0
else
	CC     += -miphoneos-version-min=5.0
	CFLAGS += -miphoneos-version-min=5.0
endif
else ifneq (,$(findstring qnx,$(platform)))
   TARGET := $(TARGET_NAME)_libretro_qnx.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   GL_LIB := -lGL

   CC = qcc -Vgcc_ntoarmv7le
   AR = qcc -Vgcc_ntoarmv7le
   CFLAGS += -DGLES
   GL_LIB := -lGLESv2
   GLES := 1
else ifneq (,$(findstring armv,$(platform)))
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I.
ifneq (,$(findstring gles,$(platform)))
   GLES := 1
else
   GL_LIB := -lGL
endif
ifneq (,$(findstring cortexa8,$(platform)))
   CFLAGS += -marm -mcpu=cortex-a8
else ifneq (,$(findstring cortexa9,$(platform)))
   CFLAGS += -marm -mcpu=cortex-a9
endif
   CFLAGS += -marm
ifneq (,$(findstring neon,$(platform)))
   CFLAGS += -mfpu=neon
endif
ifneq (,$(findstring softfloat,$(platform)))
   CFLAGS += -mfloat-abi=softfp
else ifneq (,$(findstring hardfloat,$(platform)))
   CFLAGS += -mfloat-abi=hard
endif
   CFLAGS += -DARM
# emscripten
else ifeq ($(platform), emscripten)
	TARGET := $(TARGET_NAME)_libretro_emscripten.bc
else
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   GL_LIB := -lopengl32
   CFLAGS += -I..
endif

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
else
   CFLAGS += -O3
endif

ifneq (,$(findstring qnx,$(platform)))
	CFLAGS += -Wc,-std=c99
else
	CFLAGS += -std=gnu99
endif

OBJECTS := libretro_gl_ff_test.o ../../libretro-common/glsym/rglgen.o
CFLAGS += -Wall -pedantic $(fpic)

ifeq ($(GLES), 1)
   CFLAGS += -DGLES -DHAVE_OPENGLES2
   ifeq ($(GLES31), 1)
      CFLAGS += -DHAVE_OPENGLES3 -DGLES31 -DGLES3
   else ifeq ($(GLES3), 1)
      CFLAGS += -DHAVE_OPENGLES3 -DGLES3
   endif
   LIBS += -lGLESv2 # Still link against GLESv2 when using GLES3 API, at least on desktop Linux.
   OBJECTS += ../../libretro-common/glsym/glsym_es2.o
else
   OBJECTS += ../../libretro-common/glsym/glsym_gl.o
   LIBS += $(GL_LIB)
endif

ifeq ($(CORE), 1)
   CFLAGS += -DCORE
endif

all: $(TARGET)

$(TARGET): $(OBJECTS)
	$(CC) $(fpic) $(SHARED) $(INCLUDES) -o $@ $(OBJECTS) $(LIBS) -lm $(EXTRA_GL_LIBS)

%.o: %.c
	$(CC) -I../../libretro-common/include $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)

.PHONY: clean

=== libretro-test-gl/Makefile ===
ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
		arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	system_platform = osx
	arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

TARGET_NAME = testgl

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   GL_LIB := -lGL
else ifneq (,$(findstring osx,$(platform)))
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   GL_LIB := -framework OpenGL
   CFLAGS += -DOSX
	ifeq ($(arch),ppc)
		CFLAGS += -D__ppc__ -DOSX_PPC
	endif
	OSXVER = `sw_vers -productVersion | cut -d. -f 2`
	OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
	fpic += -mmacosx-version-min=10.1
else ifeq ($(platform), pi)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/vmcs_host/linux
   GLES := 1
   LIBS += -L/opt/vc/lib
else ifneq (,$(findstring ios,$(platform)))
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
endif

   GL_LIB := -framework OpenGLES
   DEFINES := -DIOS
   CFLAGS += -DGLES $(DEFINES)
   CC = cc -arch armv7 -isysroot $(IOSSDK)
ifeq ($(platform),ios9)
	CC     += -miphoneos-version-min=8.0
	CFLAGS += -miphoneos-version-min=8.0
else
	CC     += -miphoneos-version-min=5.0
	CFLAGS += -miphoneos-version-min=5.0
endif
else ifneq (,$(findstring qnx,$(platform)))
   TARGET := $(TARGET_NAME)_libretro_qnx.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   GL_LIB := -lGL

   CC = qcc -Vgcc_ntoarmv7le
   AR = qcc -Vgcc_ntoarmv7le
   CFLAGS += -DGLES
   GL_LIB := -lGLESv2
   GLES := 1
else ifneq (,$(findstring armv,$(platform)))
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I.
ifneq (,$(findstring gles,$(platform)))
   GLES := 1
else
   GL_LIB := -lGL
endif
ifneq (,$(findstring cortexa8,$(platform)))
   CFLAGS += -marm -mcpu=cortex-a8
else ifneq (,$(findstring cortexa9,$(platform)))
   CFLAGS += -marm -mcpu=cortex-a9
endif
   CFLAGS += -marm
ifneq (,$(findstring neon,$(platform)))
   CFLAGS += -mfpu=neon
endif
ifneq (,$(findstring softfloat,$(platform)))
   CFLAGS += -mfloat-abi=softfp
else ifneq (,$(findstring hardfloat,$(platform)))
   CFLAGS += -mfloat-abi=hard
endif
   CFLAGS += -DARM
# emscripten
else ifeq ($(platform), emscripten)
	TARGET := $(TARGET_NAME)_libretro_emscripten.bc
else
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   GL_LIB := -lopengl32
   CFLAGS += -I..
endif

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
else
   CFLAGS += -O3
endif

ifneq (,$(findstring qnx,$(platform)))
	CFLAGS += -Wc,-std=c99
else
	CFLAGS += -std=gnu99
endif

OBJECTS := libretro_gl_test.o ../../libretro-common/glsym/rglgen.o
CFLAGS += -Wall -pedantic $(fpic)

ifeq ($(GLES), 1)
   CFLAGS += -DGLES -DHAVE_OPENGLES2
   ifeq ($(GLES31), 1)
      CFLAGS += -DHAVE_OPENGLES3 -DGLES31 -DGLES3
   else ifeq ($(GLES3), 1)
      CFLAGS += -DHAVE_OPENGLES3 -DGLES3
   endif
   LIBS += -lGLESv2 # Still link against GLESv2 when using GLES3 API, at least on desktop Linux.
   OBJECTS += ../../libretro-common/glsym/glsym_es2.o
else
   OBJECTS += ../../libretro-common/glsym/glsym_gl.o
   LIBS += $(GL_LIB)
endif

ifeq ($(CORE), 1)
   CFLAGS += -DCORE
endif

all: $(TARGET)

$(TARGET): $(OBJECTS)
	$(CC) $(fpic) $(SHARED) $(INCLUDES) -o $@ $(OBJECTS) $(LIBS) -lm $(EXTRA_GL_LIBS)

%.o: %.c
	$(CC) -I../../libretro-common/include $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)

.PHONY: clean

=== libretro-test-vulkan-async-compute/Makefile ===
ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
		arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

TARGET_NAME = testvulkan_async_compute

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
else
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I..
endif

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
else
   CFLAGS += -O3
endif

CFLAGS += -std=gnu99 -I../../gfx/include
OBJECTS := libretro-test.o ../../libretro-common/vulkan/vulkan_symbol_wrapper.o
CFLAGS += -Wall -pedantic $(fpic)

all: $(TARGET)

$(TARGET): $(OBJECTS)
	$(CC) $(fpic) $(SHARED) $(INCLUDES) -o $@ $(OBJECTS) $(LIBS) -lm

%.o: %.c
	$(CC) -I../../libretro-common/include $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)

.PHONY: clean

=== libretro-test-vulkan/Makefile ===
ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
		arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

TARGET_NAME = testvulkan

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
else
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
   CFLAGS += -I..
endif

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
else
   CFLAGS += -O3
endif

CFLAGS += -std=gnu99 -I../../gfx/include
OBJECTS := libretro-test.o ../../libretro-common/vulkan/vulkan_symbol_wrapper.o
CFLAGS += -Wall -pedantic $(fpic)

all: $(TARGET)

$(TARGET): $(OBJECTS)
	$(CC) $(fpic) $(SHARED) $(INCLUDES) -o $@ $(OBJECTS) $(LIBS) -lm

%.o: %.c
	$(CC) -I../../libretro-common/include $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)

.PHONY: clean

=== libretro-test/Makefile ===
STATIC_LINKING := 0
AR             := ar

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	system_platform = osx
	arch = intel
ifeq ($(shell uname -p),powerpc)
	arch = ppc
endif
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

TARGET_NAME := test
LIBM		= -lm

ifeq ($(ARCHFLAGS),)
ifeq ($(archs),ppc)
   ARCHFLAGS = -arch ppc -arch ppc64
else
   ARCHFLAGS = -arch i386 -arch x86_64
endif
endif

ifeq ($(platform), osx)
ifndef ($(NOUNIVERSAL))
   CFLAGS += $(ARCHFLAGS)
   LFLAGS += $(ARCHFLAGS)
endif
endif

ifeq ($(STATIC_LINKING), 1)
EXT := a
endif

ifeq ($(platform), unix)
	EXT ?= so
   TARGET := $(TARGET_NAME)_libretro.$(EXT)
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
else ifeq ($(platform), linux-portable)
   TARGET := $(TARGET_NAME)_libretro.$(EXT)
   fpic := -fPIC -nostdlib
   SHARED := -shared -Wl,--version-script=link.T
	LIBM :=
else ifneq (,$(findstring osx,$(platform)))
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
else ifneq (,$(findstring ios,$(platform)))
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
	fpic := -fPIC
	SHARED := -dynamiclib

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
endif

	DEFINES := -DIOS
	CC = cc -arch armv7 -isysroot $(IOSSDK)
ifeq ($(platform),ios9)
CC     += -miphoneos-version-min=8.0
CFLAGS += -miphoneos-version-min=8.0
else
CC     += -miphoneos-version-min=5.0
CFLAGS += -miphoneos-version-min=5.0
endif
else ifneq (,$(findstring qnx,$(platform)))
	TARGET := $(TARGET_NAME)_libretro_qnx.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
else ifeq ($(platform), emscripten)
   TARGET := $(TARGET_NAME)_libretro_emscripten.bc
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
else ifeq ($(platform), vita)
   TARGET := $(TARGET_NAME)_vita.a
   CC = arm-vita-eabi-gcc
   AR = arm-vita-eabi-ar
   CFLAGS += -Wl,-q -Wall -O3
	STATIC_LINKING = 1
else
   CC = gcc
   TARGET := $(TARGET_NAME)_libretro.dll
   SHARED := -shared -static-libgcc -static-libstdc++ -s -Wl,--version-script=link.T -Wl,--no-undefined
endif

LDFLAGS += $(LIBM)

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
else
   CFLAGS += -O3
endif

OBJECTS := libretro-test.o
CFLAGS += -I../../libretro-common/include -Wall -pedantic $(fpic)

ifneq (,$(findstring qnx,$(platform)))
CFLAGS += -Wc,-std=c99
else
CFLAGS += -std=gnu99
endif

CFLAGS += -I../../libretro-common/include

all: $(TARGET)

$(TARGET): $(OBJECTS)
ifeq ($(STATIC_LINKING), 1)
	$(AR) rcs $@ $(OBJECTS)
else
	$(CC) $(fpic) $(SHARED) $(INCLUDES) -o $@ $(OBJECTS) $(LDFLAGS)
endif

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(OBJECTS) $(TARGET)

.PHONY: clean

=== test/Makefile ===
TESTS := test-sinc-lowest \
	test-snr-sinc-lowest \
	test-sinc-lower \
	test-snr-sinc-lower \
	test-sinc \
	test-snr-sinc \
	test-sinc-higher \
	test-snr-sinc-higher \
	test-sinc-highest \
	test-snr-sinc-highest \
	test-cc \
	test-snr-cc

LIBRETRO_COMM_DIR = ../../libretro-common

CFLAGS += -O3 -ffast-math -g -Wall -pedantic -march=native -std=gnu99
CFLAGS += -DRESAMPLER_TEST -DRARCH_DUMMY_LOG -DRARCH_INTERNAL
CFLAGS += -I$(LIBRETRO_COMM_DIR)/include -I../../

LDFLAGS += -lm

SHAREDOBJ += $(LIBRETRO_COMM_DIR)/memmap/memalign.o \
				 $(LIBRETRO_COMM_DIR)/lists/string_list.o \
				 ../..//config_file_userdata.o \
				 ../audio_resampler_driver.o \
				 $(LIBRETRO_COMM_DIR)/file/config_file.o \
				 $(LIBRETRO_COMM_DIR)/streams/file_stream.o \
				 $(LIBRETRO_COMM_DIR)/string/stdstring.o \
				 $(LIBRETRO_COMM_DIR)/file/file_path.o \
				 $(LIBRETRO_COMM_DIR)/file/retro_stat.o \
				 $(LIBRETRO_COMM_DIR)/compat/compat_strl.o \
				 $(LIBRETRO_COMM_DIR)/hash/rhash.o \

all: $(TESTS)

main-cc.o: main.c
	$(CC) -c -o $@ $< $(CFLAGS) -DRESAMPLER_IDENT='"CC"'

snr-cc.o: snr.c
	$(CC) -c -o $@ $< $(CFLAGS) -DRESAMPLER_IDENT='"CC"'

cc-resampler.o: ../drivers_resampler/cc_resampler.c
	$(CC) -c -o $@ $< $(CFLAGS)

sinc-lowest.o: ../drivers_resampler/sinc_resampler.c
	$(CC) -c -o $@ $< $(CFLAGS) -DSINC_LOWEST_QUALITY

sinc-lower.o: ../drivers_resampler/sinc_resampler.c
	$(CC) -c -o $@ $< $(CFLAGS) -DSINC_LOWER_QUALITY

sinc.o: ../drivers_resampler/sinc_resampler.c
	$(CC) -c -o $@ $< $(CFLAGS)

nearest_resampler.o: ../drivers_resampler/nearest_resampler.c
	$(CC) -c -o $@ $< $(CFLAGS)

sinc-higher.o: ../drivers_resampler/sinc.c
	$(CC) -c -o $@ $< $(CFLAGS) -DSINC_HIGHER_QUALITY

sinc-highest.o: ../drivers_resampler/sinc.c
	$(CC) -c -o $@ $< $(CFLAGS) -DSINC_HIGHEST_QUALITY

test-sinc-lowest: sinc-lowest.o ../audio_utils.o main.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-sinc-lowest: sinc-lowest.o ../audio_utils.o snr.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-sinc-lower: sinc-lower.o ../audio_utils.o main.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-sinc-lower: sinc-lower.o ../audio_utils.o snr.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-sinc: sinc.o ../audio_utils.o main.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-sinc: sinc.o ../audio_utils.o snr.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-sinc-higher: sinc-higher.o ../audio_utils.o main.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-sinc-higher: sinc-higher.o ../audio_utils.o snr.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-sinc-highest: sinc-highest.o ../audio_utils.o main.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-sinc-highest: sinc-highest.o ../audio_utils.o snr.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-cc: cc-resampler.o ../audio_utils.o main-cc.o resampler-cc.o sinc.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

test-snr-cc: cc-resampler.o ../audio_utils.o snr-cc.o resampler-cc.o sinc.o nearest_resampler.o $(SHAREDOBJ)
	$(CC) -o $@ $^ $(LDFLAGS)

%.o: %.c
	$(CC) -c -o $@ $< $(CFLAGS)

clean:
	rm -f $(TESTS)
	rm -f *.o
	rm -f ../*.o

.PHONY: clean

=== video_filters/Makefile ===
compiler    := gcc
extra_flags :=
use_neon    := 0
release	    := release
DYLIB	    := so

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
   arch = intel
ifeq ($(shell uname -p),powerpc)
   arch = ppc
endif
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

ifeq ($(platform),gcc)
extra_rules_gcc := $(shell $(compiler) -dumpmachine)
endif

ifneq (,$(findstring armv7,$(extra_rules_gcc)))
extra_flags += -mcpu=cortex-a9 -mtune=cortex-a9 -mfpu=neon
use_neon := 1
endif

ifneq (,$(findstring hardfloat,$(extra_rules_gcc)))
extra_flags += -mfloat-abi=hard
endif

ifeq (release,$(build))
extra_flags += -O2
endif

ifeq (debug,$(build))
extra_flags += -O0 -g
endif

ldflags := $(LDFLAGS) -shared -Wl,--version-script=link.T

ifeq ($(platform), unix)
DYLIB = so
else ifeq ($(platform), osx)
compiler := $(CC)
DYLIB = dylib
ldflags := -dynamiclib
else
extra_flags += -static-libgcc -static-libstdc++
DYLIB = dll
endif

CC      := $(compiler)
CXX     := $(subst CC,++,$(compiler))
flags   := $(CFLAGS) -fPIC $(extra_flags) -I../../libretro-common/include
asflags := $(ASFLAGS) -fPIC  $(extra_flags)
objects :=
flags   += -std=c99


ifeq (1,$(use_neon))
ASMFLAGS := -INEON/asm
asflags += -mfpu=neon
endif
           
objects += blargg_ntsc_snes.$(DYLIB) phosphor2x.$(DYLIB) epx.$(DYLIB) lq2x.$(DYLIB) 2xsai.$(DYLIB) super2xsai.$(DYLIB) supereagle.$(DYLIB) 2xbr.$(DYLIB) darken.$(DYLIB) scale2x.$(DYLIB)

all: build;

%.o: %.S
	$(CC) -c -o $@ $(asflags)  $(ASMFLAGS)  $<

%.o: %.c
	$(CC) -c -o $@ $(flags) $<

%.$(DYLIB): %.o
	$(CC) -o $@ $(ldflags) $(flags) $^

build: $(objects)

clean:
	rm -f *.o
	rm -f *.$(DYLIB)

strip:
	strip -s *.$(DYLIB)

=== apple/iOS/Makefile ===
APPVERSION = 1.0.0.4
PACKAGE_VERSION = 1.0.0.4

DEPLOYMENT_IOSVERSION = 5.0
TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
ARCHS = armv7
TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
include $(THEOS)/makefiles/common.mk

SRC_DIR := ../..

APPLICATION_NAME = RetroArch
${APPLICATION_NAME}_FRAMEWORKS = Foundation UIKit CoreGraphics AudioToolbox GLKit OpenGLES CoreText CoreLocation CoreAudio AVFoundation CoreMedia CoreVideo GameController
${APPLICATION_NAME}_FILES = $(SRC_DIR)/griffin/griffin.c \
		  $(SRC_DIR)/griffin/griffin_objc.m \
		  $(SRC_DIR)/audio/audio_utils_neon.S \
		  $(SRC_DIR)/audio/drivers_resampler/sinc_neon.S \
		  $(SRC_DIR)/audio/drivers_resampler/cc_resampler_neon.S

COMMON_FLAGS := -DIOS -DHAVE_GRIFFIN -DHAVE_CORELOCATION -DHAVE_NETPLAY -DHAVE_RGUI -DHAVE_MENU -DHAVE_DYNAMIC -DHAVE_OPENGL -DHAVE_FBO -DHAVE_OPENGLES -DHAVE_OPENGLES2 -DHAVE_GLSL -DINLINE=inline -DHAVE_THREADS -D__LIBRETRO__ -DRARCH_MOBILE -std=gnu99 -DHAVE_COREAUDIO -DHAVE_FBO -DHAVE_OVERLAY -DHAVE_ZLIB -DWANT_ZLIB -DSINC_LOWER_QUALITY -DRARCH_INTERNAL -DHAVE_FILTERS_BUILTIN -DHAVE_XMB -D_LZMA_UINT32_IS_ULONG -DHAVE_STRL
COMMON_FLAGS += -DHAVE_AVFOUNDATION
COMMON_IOS_FLAGS := -Wno-deprecated-declarations -Wno-error
COMMON_IOS_OBJCFLAGS := -fobjc-arc 
INCFLAGS       := -I$(SRC_DIR) -I$(SRC_DIR)/libretro-common/include
${APPLICATION_NAME}_CFLAGS  += $(COMMON_FLAGS) $(COMMON_IOS_FLAGS) $(COMMON_IOS_OBJCFLAGS) $(INCFLAGS)
${APPLICATION_NAME}_CCFLAGS += $(COMMON_FLAGS) $(COMMON_IOS_FLAGS) $(COMMON_IOS_OBJCFLAGS) $(INCFLAGS)

include $(THEOS_MAKE_PATH)/application.mk

=== libretro-test-vulkan-async-compute/shaders/Makefile ===
COMP_SHADERS := $(wildcard *.comp)
SPIRV := $(COMP_SHADERS:.comp=.comp.inc)

GLSLANG := glslc
GLSLFLAGS := -mfmt=c

all: $(SPIRV)

%.comp.inc: %.comp
	$(GLSLANG) $(GLSLFLAGS) -o $@ $<

clean:
	rm -f $(SPIRV)

.PHONY: clean

=== debian/changelog ===
retroarch (1.3.6+dfsg1-1) unstable; urgency=low

  * New upstream release.
  * Changed package maintainer to Debian Games Team.
  * Fixed hardening-no-bindnow, hardening-no-pie.
  * Fixed hardening-no-fortify-functions (CPPFLAGS patch).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Tue, 23 Aug 2016 22:44:00 -0300

retroarch (1.3.0+dfsg1-1) unstable; urgency=low

  * Removed Sony copyrighted files.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Tue, 17 May 2016 22:21:00 -0300

retroarch (1.3.0-2) unstable; urgency=low

  * Removed debug packages from control (automatic -dbgsym packages).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 10 Apr 2016 22:36:00 -0300

retroarch (1.3.0-1) unstable; urgency=low

  * Initial release (Closes: #792608).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 23 Mar 2016 22:55:00 -0300

=== debian/control ===
Source: retroarch
Section: otherosfs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends: debhelper (>= 9),
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavutil-dev,
               libc6-dev (>= 2.13),
               libdrm-dev,
               libegl1-mesa-dev,
               libfreetype6-dev,
               libgbm-dev (>= 9.0),
               libglm-dev,
               libjack-jackd2-dev,
               libopenal-dev,
               libpulse-dev,
               libsdl2-dev,
               libswscale-dev,
               libudev-dev,
               libusb-1.0-0-dev (>= 1.0.16),
               libv4l-dev,
               libxinerama-dev,
               libxml2-dev,
               libxv-dev,
               libxxf86vm-dev,
               libvulkan-dev,
               pkg-config,
               python3-dev,
               x11proto-xext-dev,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://www.libretro.com/

Package: retroarch
Architecture: any
Depends: fonts-dejavu-core,
         libretro-core-info,
         retroarch-assets,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Simple frontend for the libretro library
 RetroArch is an open source, multi-platform frontend for the libretro API.
 It can be used as a modular multi emulator system, game engine, media player
 and 3D technical demonstration. These features are available through
 libretro cores.
 .
 It provides three built-in GUI: RGUI, XMB and GLUI.

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2012-2015 Hunter Kaller
# Copyright (C) 2014-2016 Sergio Benjamim

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Fix hardening-no-bindnow and hardening-no-pie
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_CXXFLAGS_MAINT_STRIP=-O2
export DEB_CFLAGS_MAINT_STRIP=-O2

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH), $(filter $(ARCH), amd64 i386))
	CONFIG_EXTRA_FLAGS=--enable-sse
else ifeq ($(ARCH),armhf)
	CONFIG_EXTRA_FLAGS=--disable-vg --disable-cg --enable-gles --enable-neon --enable-floathard
else ifeq ($(ARCH),arm64)
	CONFIG_EXTRA_FLAGS=--disable-vg --disable-cg --enable-gles
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		retroarch.cfg > debian/retroarch.cfg
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		debian/retroarch.dirs.in > debian/retroarch.dirs
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		debian/retroarch.install.in > debian/retroarch.install
	# See ./configure --help for valid flags
	# disable flags (i.e. --disable-ffmpeg for example) if there is no package relative to the feature in Build-Depends
	./configure --prefix=/usr --disable-oss $(CONFIG_EXTRA_FLAGS)

override_dh_auto_build:
	dh_auto_build
	# SoftFilters
	dh_auto_build -- -C gfx/video_filters/
	# Audio DSP plugins
	dh_auto_build -- -C audio/audio_filters/

override_dh_auto_install:

override_dh_auto_clean:
	touch config.mk
	dh_auto_clean
	dh_auto_clean -- -C gfx/video_filters/ clean
	dh_auto_clean -- -C audio/audio_filters/ clean
